package org.jeecg.modules.workOrder.controller;

import java.util.Arrays;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.system.mapper.SysUserMapper;
import org.jeecg.modules.workOrder.entity.WorkDivisionSet;
import org.jeecg.modules.workOrder.service.IWorkDivisionSetService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 派工预设
 * @Author: jeecg-boot
 * @Date:   2025-06-11
 * @Version: V1.0
 */
@Api(tags="派工预设")
@RestController
@RequestMapping("/workOrder/workDivisionSet")
@Slf4j
public class WorkDivisionSetController extends JeecgController<WorkDivisionSet, IWorkDivisionSetService> {
	@Autowired
	private IWorkDivisionSetService workDivisionSetService;
	@Autowired
	private SysUserMapper sysUserMapper;

	/**
	 * 分页列表查询
	 *
	 * @param workDivisionSet
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "派工预设-分页列表查询")
	@ApiOperation(value="派工预设-分页列表查询", notes="派工预设-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<WorkDivisionSet>> queryPageList(WorkDivisionSet workDivisionSet,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WorkDivisionSet> queryWrapper = QueryGenerator.initQueryWrapper(workDivisionSet, req.getParameterMap());
		Page<WorkDivisionSet> page = new Page<WorkDivisionSet>(pageNo, pageSize);
		IPage<WorkDivisionSet> pageList = workDivisionSetService.page(page, queryWrapper);
		pageList.getRecords().forEach(pgl->{
			SysUser user = sysUserMapper.selectById(pgl.getExecutor());
			pgl.setExecutorName(user.getRealname());
			pgl.setExecPhone(user.getPhone());
			pgl.setPostage(user.getPost());
		});
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param workDivisionSet
	 * @return
	 */
	@AutoLog(value = "派工预设-添加")
	@ApiOperation(value="派工预设-添加", notes="派工预设-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_work_division_set:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WorkDivisionSet workDivisionSet) {
		workDivisionSetService.save(workDivisionSet);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param workDivisionSet
	 * @return
	 */
	@AutoLog(value = "派工预设-编辑")
	@ApiOperation(value="派工预设-编辑", notes="派工预设-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_work_division_set:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WorkDivisionSet workDivisionSet) {
		workDivisionSetService.updateById(workDivisionSet);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "派工预设-通过id删除")
	@ApiOperation(value="派工预设-通过id删除", notes="派工预设-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_work_division_set:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		workDivisionSetService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "派工预设-批量删除")
	@ApiOperation(value="派工预设-批量删除", notes="派工预设-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_work_division_set:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.workDivisionSetService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "派工预设-通过id查询")
	@ApiOperation(value="派工预设-通过id查询", notes="派工预设-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<WorkDivisionSet> queryById(@RequestParam(name="id",required=true) String id) {
		WorkDivisionSet workDivisionSet = workDivisionSetService.getById(id);
		if(workDivisionSet==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(workDivisionSet);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param workDivisionSet
    */
    //@RequiresPermissions("org.jeecg.modules:bu_work_division_set:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WorkDivisionSet workDivisionSet) {
        return super.exportXls(request, workDivisionSet, WorkDivisionSet.class, "派工预设");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_work_division_set:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WorkDivisionSet.class);
    }

}
